<#-- Ajax comments module, included in pop up edits -->
<#-- NOTE: when the edit form is used the posting of comment data is not processed by -->
<#-- the xhr-request (PostComment.java) but in a form filter (DataListFormFilter) -->
<#-- in the afterPersist-method. -->
<#include "editorparams.inc.ftl" />

<#assign controlId = fieldHtmlId + "-cntrl">

<#if field.control.params.hideCommentButton??>
	<#assign hideCommentButton=field.control.params.hideCommentButton>
<#else>
	<#assign hideCommentButton="false">
</#if>

<#if field.control.params.civilComment??>
	<#assign civilComment=field.control.params.civilComment>
<#else>
	<#assign civilComment="false">
</#if>

  <#if form.mode == "view">
    <#if field.control.params.rows??><#assign rows=field.control.params.rows><#else><#assign rows=5></#if>
    <#if field.control.params.columns??>
      <#assign columns=field.control.params.columns>
    <#else>
      <#assign columns=60>
    </#if>
    <div class="form-field ajax-comments-view">

    <#if !(field.control.params.hideCommentTextarea?? && field.control.params.hideCommentTextarea == "true")>
      <div style="display: block;font-weight: bold" class="hide-in-print-view">
      	<#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
          <div>${msg("form.label.engComment.write")}</div>
        <#else>
          <#if field.control.params.civilComment??>
          	<div>${msg("form.label.civilComment.write")}</div>
          <#else>
          	<div>${msg("form.label.comment.write")}</div>
          </#if>
        </#if>
          <!--div class="yui-u"-->
          <!--start -->
          <script type="text/javascript">//<![CDATA[
            (function() {
                require([Alfresco.constants.URL_RESCONTEXT + "components/form/rich-text.js",
                         Alfresco.constants.URL_RESCONTEXT + "js/lyse/allsites/LyseRichTextControl.js",
                         Alfresco.constants.URL_RESCONTEXT + "components/form/comments.js"], function(){
                 var art=new Alfresco.LyseRichTextControl("${fieldHtmlId}").setOptions(
                      {
                              <#if form.mode == "view" || (field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true"))>disabled: false,</#if>
                          currentValue: "${field.value?string}",
                          mandatory: ${field.mandatory?string},
                          <@editorParameters field />
                      }).setMessages(${messages});


               var commentsControl = new Alfresco.CommentsControls("${fieldHtmlId}-list").setOptions({
                   height: ${args.editorHeight!180},
                   width: ${args.editorWidth!700},
                   <#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
                   	  commentTopic: "engineeringComments",
                   <#else>
                   	  commentTopic: "Comments",
                   </#if>
                   <#if (field.control.params.loadPermissionGroups?? && field.control.params.loadPermissionGroups == "true")>
                   	  loadPermissionGroups: true,
                   </#if>
                   <#if (form.mode == "view") && args.itemId??>
                      itemNodeRef: "${args.itemId?string}"
                   <#else>
                      itemNodeRef: ""
                   </#if>
                   
               }).setMessages(${messages});
               commentsControl.onReady();  <#-- Seems to be necessary when loaded from Ajax -->


               <#-- Add listener to Comments submit button. Also see code duplicated below -->
               YAHOO.util.Event.addListener("${fieldHtmlId}-list-form-submit-button","click",function(e){
                 var clickedButton = e.target;
                 <#-- Strip HTML tags and &nbsp; so we can check if the comment is really empty -->
                 var stripHTML = /<\S[^><]*>/g;
                 var commentText = art.editor.getContent({format: 'html'}).replace(stripHTML, "").replace(/&nbsp;/g,"");
                 if (YAHOO.lang.trim(commentText).length > 0) {
                   clickedButton.disabled = true;
                   Alfresco.util.Ajax.jsonPost({
                                <#if !(field.control.params.companyInternal?? && field.control.params.companyInternal == "true")>
                                	<#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
                                    	url: Alfresco.constants.PROXY_URI + "api/lyse/${args.itemId?replace('://','/')}/comment?internal=false&engineeringComment=true&civilComment=${civilComment}",
                                	<#else>
                                		url: Alfresco.constants.PROXY_URI + "api/lyse/${args.itemId?replace('://','/')}/comment?internal=false&engineeringComment=false&civilComment=${civilComment}",
                                	</#if>
                                <#else>
                                    <#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
                                    	url: Alfresco.constants.PROXY_URI + "api/lyse/${args.itemId?replace('://','/')}/comment?internal=true&engineeringComment=true&civilComment=${civilComment}",
                                	<#else>
                                		url: Alfresco.constants.PROXY_URI + "api/lyse/${args.itemId?replace('://','/')}/comment?internal=true&engineeringComment=false&civilComment=${civilComment}",
                                	</#if>
                                </#if>

                                dataObj: {
                                    content: art.editor.getContent()
                                },
                                successCallback: {
                                    fn: function () {
                                        // Clear editor and reload comments
                                        art.editor.setContent("");
                                        commentsControl._loadCommentsList(0);
                                        clickedButton.disabled = false;
                                    },
                                    scope: this
                                },
                               failureCallback: {
                                   fn: function () {
                                       commentsControl._loadCommentsList(0);
                                       clickedButton.disabled = false;
                                       Alfresco.util.PopupManager.displayPrompt(
                                               {
                                                   title: Alfresco.util.message("message.failure", this.name),
                                                   text: "Failed to add comment!"
                                               });
                                   },
                                   scope: this
                               }
                   });
                 }
               });
              });
            })();
          //]]></script>

          <textarea id="${fieldHtmlId}" name="${field.name}" rows="${rows}" columns="${columns}" tabindex="0"
                    <#if field.description??>title="${field.description}"</#if>
                    <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
                    <#if field.control.params.style??>style="${field.control.params.style}"</#if>
                    <#if field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="false"</#if>></textarea>

      <!--end-->

      </div>
    </#if>

    <br />
    <br />

    <#if hideCommentButton == "false">
        <div>
          <input id="${fieldHtmlId}-list-form-submit-button" type="button" value="${msg("form.label.comment.add")}"/>
        </div>
    </#if>
  </#if>

  <#if form.mode == "edit">
    <div class="form-field ajax-comments-edit">
        <#if !(field.control.params.hideCommentTextarea?? && field.control.params.hideCommentTextarea == "true")>
          <#if field.control.params.rows??><#assign rows=field.control.params.rows><#else><#assign rows=5></#if>
          <#if field.control.params.columns??><#assign columns=field.control.params.columns><#else><#assign columns=60></#if>
      	<#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
          <div>${msg("form.label.engComment.write")}<#if field.endpointMandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></div>
        <#else>
          <#if field.control.params.civilComment??>
          	<div>${msg("form.label.civilComment.write")}<#if field.endpointMandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></div>
          <#else>
          	<div>${msg("form.label.comment.write")}<#if field.endpointMandatory><span class="mandatory-indicator">${msg("form.required.fields.marker")}</span></#if></div>
          </#if>

          
        </#if>

           <!--div class="yui-u"-->
           <!--start -->
           <script type="text/javascript">//<![CDATA[
           (function() {
               var art=new Alfresco.LyseRichTextControl("${fieldHtmlId}").setOptions(
                       {<#if form.mode == "edit" || (field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true"))>disabled: false,</#if>
                           currentValue: "${field.value?js_string}",
                           mandatory: ${field.mandatory?string},
                           <@editorParameters field />
                       }).setMessages(${messages});

               var commentsControl = new Alfresco.CommentsControls("${fieldHtmlId}-list").setOptions({
                   height: ${args.editorHeight!180},
                   width: ${args.editorWidth!700},
                   <#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
                   	  commentTopic: "engineeringComments",
                   <#else>
                   	  commentTopic: "Comments",
                   </#if>
                   <#if (field.control.params.loadPermissionGroups?? && field.control.params.loadPermissionGroups == "true")>
                   	  loadPermissionGroups: true,
                   </#if>

                   <#if (form.mode == "edit") && args.itemId??>
                       itemNodeRef: "${args.itemId?js_string}"
                   <#else>
                       itemNodeRef: ""
                   </#if>
               }).setMessages(${messages});
               commentsControl.onReady();  <#-- Seems to be necessary when loaded from Ajax -->

           })();
           //]]></script>

          <textarea id="${fieldHtmlId}" name="${field.name}" rows="${rows}" cols="${columns}" tabindex="0"
            <#if field.description??>title="${field.description}"</#if>
            <#if field.control.params.styleClass??>class="${field.control.params.styleClass}"</#if>
            <#if field.control.params.style??>style="${field.control.params.style}"</#if>
            <#if field.disabled && !(field.control.params.forceEditable?? && field.control.params.forceEditable == "true")>disabled="true"</#if>></textarea>
          <@formLib.renderFieldHelp field=field />
    </div>
    <#-- End of "edit" form mode -->
    </#if>
  </#if>

  <#-- Common for edit and view -->
  <div id="${fieldHtmlId}-list" class="comment-list" style="display:none;">
    <div class="postlist-infobar">
      <div id="${fieldHtmlId}-list-paginator" class="paginator"></div>
    </div>
    <div class="clear"></div>
        <#if (field.control.params.engineeringComment?? && field.control.params.engineeringComment == "true")>
          <div>${msg("form.label.engComment.list")}</div>
        <#else>
          <#if field.control.params.civilComment??>
          	<div>${msg("form.label.civilComment.list")}</div>
          <#else>
          	<h3>${msg("form.label.comments")}</h3>
          </#if>
        </#if>

    
    <div id="${fieldHtmlId}-list-comments"></div>
  </div>
