model.jsonModel = {
  widgets: [
    {
      name: "lyse/reports/overview",
      config: {
          dataLists:
          [
            {
              dataList: "actionlistmember",
              dataListName: "Actions Per Member",
              sitetype:"contractor-project",
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count'],
              showChart: false,
              orderList: false,
            },
            {
              dataList: "civilactionlistmember",
              dataListName: "Actions Per Member",
              sitetype:"civil-site",
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count'],
              showChart: false,
              orderList: false,
            },
            {
              dataList: "interfaceactionlistmember",
              dataListName: "Actions Per Member",
              sitetype:"interface-site",
              columns: ['user', 'draft_count', 'action_count', 'done_count', 'overdue_count', 'for_closing_count', 'closed_count'],
              showChart: false,
              orderList: false,
            }
          ],
          overrides:
          [
            {
              dataList: "mcc-signals-test-status-remote",
              override: "mccSignal",
              dataListName: "Signals - Test status (remote)",
              sitetype:"mcc-site",
              showChart: true,
              orderList: false,
              dataListURLParam: "Signals",
              filterStatusProperty: "prop_lyse_mccSignalTestStatusRemote",
              filterStatusConstraints: {
                "New or Revised": "New or Revised",
                "For Approval": "For Approval",
                "Approved": "Approved",
                "Approved with comments": "Approved with comments",
                "Rejected": "Rejected",
                "Voided": "Voided",
                "Not applicable":"Not applicable"
              }
            },
            {
              dataList: "mcc-signals-test-status-local",
              override: "mccSignal",
              dataListName: "Signals - Test status (local)",
              sitetype:"mcc-site",
              showChart: true,
              orderList: false,
              dataListURLParam: "Signals",
              filterStatusProperty: "prop_lyse_mccSignalTestStatusLocal",
              filterStatusConstraints: {
                "New or Revised": "New or Revised",
                "For Approval": "For Approval",
                "Approved": "Approved",
                "Approved with comments": "Approved with comments",
                "Rejected": "Rejected",
                "Voided": "Voided"
              }
            }
          ],
          extensions:
          [	
            {
          		extend: "genericDocumentList",
          		forceLinks: true
            },
          	{
          	  extend: "ncrList",
              filterBeforeOverdueProperties: {
              	"prop_lysedl_ncrDate":"prop_lysedl_ncrStatus%3Dreview"
              }
          	},
          	{
          	  extend: "correspondenceItem",
              filterBeforeOverdueProperties: {
              	"prop_lysedl_correspondenceDueDate":"prop_lysedl_correspondenceStatus%3Dopen"
              }
          	},
          	{
          	  extend: "civilCorrespondenceItem",
              filterBeforeOverdueProperties: {
              	"prop_lysedl_civilCorrespondenceDueDate":"prop_lysedl_civilCorrespondenceStatus%3Dopen"
              }
          	},
          	{
          	  extend: "cdlDataList",
              filterBeforeOverdueProperties: {
              	"prop_lyse_cdlReviewDueDate":"prop_lyse_cdlReviewStatus%3DcompanyReview",
              	"prop_lyse_cdlDueDate":"prop_lyse_cdlReviewStatus%3Ddraft"
              }
          	},
            {
          	  extend: "milestoneItem",
              showTotals: true
            },
            {
          	  extend: "variationOrderRequestItem",
              showTotals: true,
              excludeTotals: ["VOR-withdrawn"]
            }
          ]
      }
    },
  ]
};
