window.RPLP = window.RPLP || {};
window.RPLP.selectedNodeType = "";
(function() {
  /**
   * YUI Library aliases
   */
  var Dom = YAHOO.util.Dom, Event = YAHOO.util.Event, Selector = YAHOO.util.Selector, Bubbling = YAHOO.Bubbling;
  var isLoading = false;

  /**
   * Alfresco Slingshot aliases
   */
  var $html = Alfresco.util.encodeHTML, $links = Alfresco.util.activateLinks, $combine = Alfresco.util.combinePaths, $userProfile = Alfresco.util.userProfileLink;

  Alfresco.component.ExtDataListToolbar = function(htmlId) {
    return Alfresco.component.ExtDataListToolbar.superclass.constructor.call(this, htmlId);
  };

  /**
   * Extend Alfresco.component.DataGrid
   */
  YAHOO.extend(Alfresco.component.ExtDataListToolbar, Alfresco.component.DataListToolbar);

  /**
   * Augment prototype with Common Actions module
   */
  YAHOO.lang.augmentProto(Alfresco.component.ExtDataListToolbar, Alfresco.service.DataListActions);

  /**
   * Augment prototype with main class implementation, ensuring overwrite is
   * enabled
   */
  YAHOO.lang.augmentObject(Alfresco.component.ExtDataListToolbar.prototype, {
    /**
     * Fired by YUI when parent element is available for scripting.
     *
     * @method onReady
     */
    onReady : function DataListToolbar_onReady() {
      this.widgets.exportCsvButton = Alfresco.util.createYUIButton(this, "exportCsvButton", this.onExportCsv, {
        disabled : true
      });
      this.widgets.importCsvButton = Alfresco.util.createYUIButton(this, "importCsvButton", this.onImportCsv, {
        disabled : true,
      });
      this.widgets.workflowDiagramButton = Alfresco.util.createYUIButton(this, "workflowDiagramButton", this.onWorkflowDiagram, {
        disabled : true
      });
      this.widgets.newVoButton = Alfresco.util.createYUIButton(this, "newVoButton", this.onNewVO, {
        disabled: true,
        value : "createVO"
      });
      this.widgets.newVorButton = Alfresco.util.createYUIButton(this, "newVorButton", this.onNewVOR, {
        disabled: true,
        value : "createVOR"
      });
      this.widgets.newCivilVoButton = Alfresco.util.createYUIButton(this, "newCivilVoButton", this.onNewVO, {
        disabled: true,
        value : "createCivilVO"
      });
      this.widgets.newCivilVorButton = Alfresco.util.createYUIButton(this, "newCivilVorButton", this.onNewVOR, {
        disabled: true,
        value : "createCivilVOR"
      });

      this.widgets.newNcrButton = Alfresco.util.createYUIButton(this, "newNcrButton", this.onNewNCR, {
          disabled: true,
          value : "createNCR"
      });

      this.widgets.newMilestoneButton = Alfresco.util.createYUIButton(this, "newMilestoneButton", this.onNewMilestone, {
        disabled: true,
        value : "createMilestone"
      });

      this.widgets.newCivilMilestoneButton = Alfresco.util.createYUIButton(this, "newCivilMilestoneButton", this.onNewCivilMilestone, {
        disabled: true,
        value : "createCivilMilestone"
      });

      if (Alfresco.util.getQueryStringParameter("list", document.location.href) == null) {
        // If no list is selected hide these buttons, so it only displays the disabled "New Item" button
        this.widgets.newVoButton.destroy();
        this.widgets.newVorButton.destroy();
        this.widgets.newNcrButton.destroy();
        this.widgets.newMilestoneButton.destroy();
        this.widgets.newCivilMilestoneButton.destroy();
        this.widgets.newCivilVoButton.destroy();
        this.widgets.newCivilVorButton.destroy();
      }

      Alfresco.util.Ajax.jsonGet({
        url: Alfresco.constants.PROXY_URI + "api/people/"+Alfresco.constants.USERNAME,
        responseContentType : "application/json",
        successCallback: {
          fn: function (response) {
            var isAdmin = response.json.isAdminAuthority;
            var importableLists = ["Contractors Documents", "Signals", "Generic Documents", "Meetings", "Measured quantity"];

            if(!isAdmin) {
              // Check if user is SiteManager
              var siteName = this.options.siteId;
              Alfresco.util.Ajax.jsonGet({
                url: Alfresco.constants.PROXY_URI + "api/sites/" + siteName + "/memberships/" + Alfresco.constants.USERNAME,
                responseContentType :  "application/json",
                successCallback: {
                  fn: function (response) {
                    var role = response.json.role;
                    if(role !== "SiteManager" || importableLists.indexOf(Alfresco.util.getQueryStringParameter("list", document.location.href)) < 0) {
                      this.widgets.importCsvButton.destroy();
                    }
                  },
                  scope: this
                }
              });
            } else {
              if(importableLists.indexOf(Alfresco.util.getQueryStringParameter("list", document.location.href)) < 0) {
                this.widgets.importCsvButton.destroy();
              }
            }
          },
          scope: this
        }
      });

      Bubbling.on("activeDataListChanged", this.onActiveDataListChanged, this);
      Alfresco.component.ExtDataListToolbar.superclass.onReady.call(this);
    },

    onActiveDataListChanged : function ExtDatalistToolbar_onActiveDataListChanged(layer, args) {
      var obj = args[1];
      if ((obj !== null) && (obj.dataList !== null)) {
        var dlType = obj.dataList.itemType;
        if ("lysedl:variationOrderRequestItem" === obj.dataList.itemType) {
          this.widgets.newRowButton.destroy();
        } else {
          this.widgets.newVoButton.destroy();
          this.widgets.newVorButton.destroy();
        }
        if ("lysedl:civilVariationOrderRequestItem" === obj.dataList.itemType) {
           this.widgets.newRowButton.destroy();
        } else {
              this.widgets.newCivilVoButton.destroy();
              this.widgets.newCivilVorButton.destroy();
        }

        if ("lysedl:ncrList" === obj.dataList.itemType){
        	this.widgets.newRowButton.destroy();
        } else {
        	this.widgets.newNcrButton.destroy();
        }

        if ("lysedl:milestoneItem" === obj.dataList.itemType){
          this.widgets.newRowButton.destroy();
        } else {
          this.widgets.newMilestoneButton.destroy();
        }

        if ("lysedl:civilMilestone" === obj.dataList.itemType){
          this.widgets.newRowButton.destroy();
        } else {
          this.widgets.newCivilMilestoneButton.destroy();
        }

        // Remove the "Workflow Diagram" button if the current data list has no workflow
        switch (obj.dataList.itemType) {
          case "lysedl:cdlDataList":
          case "lysedl:contractDataList":
          case "lysedl:correspondenceItem":
          case "lysedl:epbDataList":
          case "lysedl:iasDataList":
          case "lysedl:interfaceAction":
          case "lysedl:irlDataList":
          case "lysedl:issueList":
          case "lysedl:milestoneItem":
          case "lysedl:ncrList":
          case "lysedl:punchList":
          case "lysedl:civilPunchList":
          case "lysedl:ruiList":
          case "lysedl:qaList":
          case "lysedl:hseAction":
          case "lysedl:variationOrderRequestItem":
          case "lysedl:sjaDataList":
          case "lysedl:riskReducingMeasures":
          case "lysedl:civilCdlDataList":
          case "lysedl:civilMilestone":
          case "lysedl:civilTechnicalQuery":
          case "lysedl:companysDocumentDataList":
          case "lysedl:userFeedback":
          case "lysedl:civilAction":
          case "lysedl:civilVariationOrderRequestItem":
          case "lysedl:mccCommissioningPackages":
          case "lysedl:mccPackages":
          case "lysedl:mccAction":
          case "lysedl:actionWithProject":
          case "lysedl:civilMeasuredQuantity":
          case "lysedl:siteQuery":
          case "lysedl:siteQueries":
          case "lysedl:civilContractDataList":
          case "lysedl:contractDataList":
          case "lysedl:safeWorkPermitItem":
                break;
          default:
                this.widgets.workflowDiagramButton.destroy();
                break;
        }

      }
    },

    /**
     * Export CSV button click handler
     *
     * @method onExportCsv
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onExportCsv : function ExtDataListToolbar_onExportCsv(e, p_obj) {
      var nodeRef = Alfresco.util.NodeRef(this.modules.dataGrid.datalistMeta.nodeRef);
      var me = this;

	  // Internet Explorer
      if (YAHOO.env.ua.ie > 0) {
    	window.location.href = Alfresco.constants.PROXY_URI + "/fme/slingshot/datalists/list/node/" + nodeRef.uri + "?format=xlsx";
      }else{
        var oReq = new XMLHttpRequest();
	    oReq.onload = function(e) {
	  	  // Reset settings
      	  me.isLoading = false;
          loadingMessage.destroy();

           // Prepare data
           var blob = new Blob([this.response], {type: 'application/vnd.openxmlformats-officedocument.spreadsheetml.sheet'});
           var downloadUrl = URL.createObjectURL(blob);
           var responseHeaders = oReq.getResponseHeader("Content-Disposition");
		   var fileName = responseHeaders.substring(responseHeaders.indexOf("filename=")+9, responseHeaders.indexOf("filename=").length);

		   // Make link to download element, then delete it.
           var a = document.createElement("a");
           a.href = downloadUrl;
           a.download = fileName;
           document.body.appendChild(a);
           a.click();
           a.parentNode.removeChild(a);
	     }

         if(!this.isLoading){
      	   this.isLoading = true;
	  	   oReq.open("GET", Alfresco.constants.PROXY_URI + "/fme/slingshot/datalists/list/node/" + nodeRef.uri + "?format=xlsx");
		   oReq.responseType = 'blob'; // Get a binary response
	       oReq.send();
           var loadingMessage = Alfresco.util.PopupManager.displayMessage({
             displayTime: 0,
             text: '<span class="wait">' + $html(Alfresco.util.message("message.wait.loading")) + '</span>',
             noEscape: true
          });
        }
      }
    },

    onImportCsv : function ExtDataListToolbar_onImportCsv(e, p_obj) {
      var nodeRef = Alfresco.util.NodeRef(this.modules.dataGrid.datalistMeta.nodeRef);
      window.open(Alfresco.constants.URL_CONTEXT + 'page'+'/bulk-import?nodeRef=' + nodeRef, "_blank");
    },

    onWorkflowDiagram : function ExtDataListToolbar_onWorkflowDiagram(e, p_obj) {
      var datalistItemType = this.modules.dataGrid.datalistMeta.itemType;
      showLightbox({ src: Alfresco.constants.URL_RESCONTEXT + 'components/images/workflow-diagrams/' + datalistItemType.replace(':', '_') + '.png' });
    },

    displayCreateForm : function(e, p_obj, title, templateUrl) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      // Intercept before dialog show
      var doBeforeDialogShow = function DataListToolbar_onNewVO_doBeforeDialogShow(p_form, p_dialog) {
        Alfresco.util.populateHTML([ p_dialog.id + "-dialogTitle", this.msg(title) ]);
      };

      // Using Forms Service, so always create new instance
      var createRow = new Alfresco.module.SimpleDialog(this.id + "-createRow");

      createRow.setOptions({
        width : this.options.newItemDialogWidth,
        templateUrl : templateUrl,
        actionUrl : null,
        destroyOnHide : true,
        doBeforeDialogShow : {
          fn : doBeforeDialogShow,
          scope : this
        },
        onSuccess : {
          fn : function DataListToolbar_onNewVO_success(response) {
            YAHOO.Bubbling.fire("dataItemCreated", {
              nodeRef : response.json.persistedObject
            });

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.success")
            });
          },
          scope : this
        },
        onFailure : {
          fn : function DataListToolbar_onNewVO_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.failure")
            });
          },
          scope : this
        }
      }).show();

    },

    /**
     * New NCR button click handler
     *
     * @method onNewNCR
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewNCR : function DataListToolbar_onNewNCR(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-ncr.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&formId={formId}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    /**
     * New VO button click handler
     *
     * @method onNewVO
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewVO : function DataListToolbar_onNewVO(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-vo.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&formId={formId}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        formId : "variationOrder",
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    /**
     * New VOR button click handler (basically same as onNewRow)
     *
     * @method onNewVOR
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewVOR : function DataListToolbar_onNewVOR(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-vor.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

	onActionLockItems: function(e)
    {
      var refs = [];
      e.forEach(function(item)
      {
        refs.push(item.nodeRef);
      });
      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "api/lyse/lock-nodes",
        responseContentType : "application/json",
        dataObj : refs,
        successCallback : {
          fn : function () {

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.success")
            });
            location.reload();

          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({

              text:response.json.message || this.msg("message.failed")
            });
          },
          scope : this
        }
      });
    },

    onActionUnlockItems: function(e)
    {
      var refs = [];
      e.forEach(function(item)
      {
        refs.push(item.nodeRef);
      });
      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "api/lyse/unlock-nodes",
        responseContentType : "application/json",
        dataObj : refs,
        successCallback : {
          fn : function () {

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.success")
            });
            location.reload();

          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text:response.json.message || this.msg("message.failed")
            });
          },
          scope : this
        }
      });
    },
    /**
     * New milestone button click handler (basically same as onNewRow)
     *
     * @method onNewMilestone
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewMilestone : function DataListToolbar_onNewMilestone(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-milestone.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    onNewCivilMilestone : function DataListToolbar_onNewCivilMilestone(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      this.displayCreateForm(e, p_obj, "label.new-milestone.title", YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      }));
    },

    /**
     * Create meeting minutes click handler
     *
     * @method onActionCreateMeetingMinutes
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionCreateMeetingMinutes : function ExtDataListToolbar_onActionCreateMeetingMinutes(e, p_obj) {
      // Collect nodes to operate on.
      var actionListRefs = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        actionListRefs.push(row.nodeRef);
       }

      window.RPLP.globalActionListRefs = actionListRefs;

      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef;

      // Feed our custom apply template listbox with nodetype info via global javascript variable.
      window.RPLP.selectedNodeType = datalistMeta.itemType;

      // Intercept before dialog show
      var doBeforeDialogShow = function dlA_onActionDetails_doBeforeDialogShow(p_form, p_dialog) {
        Alfresco.util.populateHTML([ p_dialog.id + "-dialogTitle", this.msg("form.createMeetingMinutes.title") ]);
      };

      var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&formId={formId}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : "lysedl:meetingMinutes",
        mode : "create",
        destination : destination,
        submitType : "json",
        formId : "generated-meeting-minutes",
        site: Alfresco.constants.SITE
      });

      // Using Forms Service, so always create new instance
      var createMeetingMinutes = new Alfresco.module.SimpleDialog(this.id + "-createMeetingMinutes");

      createMeetingMinutes.setOptions({
        width : this.options.newItemDialogWidth,
        templateUrl : templateUrl,
        actionUrl : null,
        destroyOnHide : true,
        doBeforeDialogShow : {
          fn : doBeforeDialogShow,
          scope : this
        },
        onSuccess : {
          fn : function ExtDataListToolbar_onActionCreateMeetingMinutes_success(response) {
            window.location.href = Alfresco.constants.URL_CONTEXT + "page/site/" + encodeURIComponent(Alfresco.constants.SITE) + '/data-lists?list=Meetings'
          },
          scope : this
        },
        onFailure : {
          fn : function ExtDataListToolbar_onActionCreateMeetingMinutes_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.createMeetingMinutes.failure" + response.serverResponse.responseText)
            });
          },
          scope : this
        }
      }).show();

    },
	onVoidMilestone : function ExtDataListToolbar_onVoidMilestone (e, p_obj) {

        var nodeRefs = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          nodeRefs.push(row.nodeRef);
        }

        Alfresco.util.PopupManager.getUserInput(
        {
          title: Alfresco.util.message("dialog.void.title"),
          text: Alfresco.util.message("dialog.void.reason"),
          input: "text",
          callback:
          {
            fn: function promptCallback (comment)
            {
              url = Alfresco.constants.PROXY_URI + "lyse/api/void-milestone";

              var config =
              {
                method: "POST",
                url: url,
                successCallback:
                {
                  fn: function (response)
                  {
                    // Fire "dataItemsDuplicated" event to refresh datagrid
                    Bubbling.fire("dataItemsDuplicated");
                    Alfresco.util.PopupManager.displayMessage({
                              text : this.msg("message.success.void-milestone")
                    });
                  },
                  scope: this
                },
                failureCallback : {
                  fn : function ExtDataListToolbar_onVoidMilestone_failure(response) {
                    Alfresco.util.PopupManager.displayMessage({
                         text : this.msg("message.failure.void-milestone")
                    });
                  },
                  scope : this
                },
                dataObj:
                {
                  nodes: this,
                  comment : comment
                }
                };

              Alfresco.util.Ajax.jsonRequest(config);
            },
            scope: nodeRefs
          }
        });
	},
    /**
     * Submit for review
     *
     * @method onActionSubmitForReview
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionSubmitForReview : function ExtDataListToolbar_onActionSubmitForReview(e, p_obj) {
      // Collect nodes to operate on.
      var nodesRefs = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
        };

        if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:cdlDataList") {

          if (row.itemData.prop_lysedl_cdlCompanyReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
                {
                  text: Alfresco.util.message("message.missingReviewers.multiple")
                });
            return false;

          }
        }else if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:civilCdlDataList") {

          if (row.itemData.prop_lysedl_civilCdlCompanyReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
                {
                  text: Alfresco.util.message("message.missingReviewers.multiple")
                });
            return false;

          }
        }else if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:companysDocumentDataList") {

              if (row.itemData.prop_lysedl_companysDocumentCompanyReviewResponsibleAsText === undefined) {
                  Alfresco.util.PopupManager.displayPrompt(
                      {
                          text: Alfresco.util.message("message.missingReviewers.multiple")
                      });
                  return false;

              }
          }
        else {
          if (row.itemData.prop_lysedl_civilContractContractorReviewResponsibleAsText === undefined) {
            Alfresco.util.PopupManager.displayPrompt(
                {
                  text: Alfresco.util.message("message.missingContractorReviewers.multiple")
                });
            return false;

          }
        }

        nodesRefs.push(nodeRef);
      }

      var payload = {
 	   firstUserTask : "default",
 	   nodes : nodesRefs
 	  };

      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "/lyse/api/start-workflow",
        responseContentType : "application/json",
        dataObj : payload,
        successCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_success(response) {

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("actions.submit-for-review-success")
            });

          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionSubmitForReview_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : response.json.message
            });
          },
          scope : this
        }
      });

    },

    /**
     * Submit for IFC
     *
     * @method onActionStartIFCEngWorkflow
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionStartIFCEngWorkflow : function ExtDataListToolbar_onActionStartIFCEngWorkflow(e, p_obj) {
      // Collect nodes to operate on.
      var nodesRefs = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
        };

        if (this.modules.dataGrid.datalistMeta.itemType === "lysedl:cdlDataList") {

            if (row.itemData.assoc_lysedl_cdlCompanyReviewResponsible === undefined) {
              Alfresco.util.PopupManager.displayPrompt(
                  {
                    text: Alfresco.util.message("message.missingReviewers.multiple")
                  });
              return false;

            }
        }

        nodesRefs.push(nodeRef);
      }

      var payload = {
 	   firstUserTask : "IFC",
 	   nodes : nodesRefs
 	  };

      Alfresco.util.Ajax.jsonPost({
        url : Alfresco.constants.PROXY_URI + "/lyse/api/start-workflow",
        responseContentType : "application/json",
        dataObj : payload,
        successCallback : {
          fn : function ExtDataListToolbar_onActionStartIFCEngWorkflow_success(response) {

              var refreshItem = true;
              if (response.json) {
                  if (response.json.data.workflows.length > 0) {
                      if (response.json.data.workflows[0].tasks.length === 1) {
                          // Redirect to the assigned task if there is only one
                          var taskId = response.json.data.workflows[0].tasks[0].taskId;
                          var workflowId = response.json.data.workflows[0].workflowId;

                          refreshItem = false;
                          Alfresco.util.PopupManager.displayMessage(
                              {
                                  text: this.msg("actions.start-workflow-success")
                              });
                          window.location.href = YAHOO.lang.substitute("{context}lyse-task-edit?taskId={taskId}&workflowId="+ workflowId,
                              {
                                  context: Alfresco.constants.URL_PAGECONTEXT,
                                  taskId: taskId
                              });


                      }
                  }
              }
              if (refreshItem) {
                  this.refreshItem(item.nodeRef, "actions.start-workflow-success");
              }


          },
          scope : this
        },
        failureCallback : {
          fn : function ExtDataListToolbar_onActionStartIFCEngWorkflow_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : response.json.message
            });
          },
          scope : this
        }
      });

    },


    /**
     * Void cdl document
     *
     * @method onActionVoid
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionVoid : function ExtDataListToolbar_onActionVoid(e, p_obj) {
      // Collect nodes to operate on.
      var nodes = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
      };

      if (typeof row.itemData.prop_lysedl_workflowId !== 'undefined') {
	        var workflowId = row.itemData.prop_lysedl_workflowId.value.toString();
	        if (workflowId) {

	             Alfresco.util.PopupManager.displayMessage(
		    	 {
		    	   text: Alfresco.util.message("message.inOngoingWorkflow")
		    	 });
	             return false;

	  	     }
         }

        nodes.push(nodeRef);
      }

      Alfresco.util.PopupManager.getUserInput(
      {
        title: Alfresco.util.message("dialog.void.title"),
        text: Alfresco.util.message("dialog.void.reason"),
        input: "text",
        callback:
        {
           fn: function promptCallback (comment)
           {
              url = Alfresco.constants.PROXY_URI + "lyse/api/void-document";

              var config =
              {
                 method: "POST",
                 url: url,
                 successCallback:
                 {
                    fn: function (response)
                    {
                        // Fire "dataItemsDuplicated" event to refresh datagrid
                        Bubbling.fire("dataItemsDuplicated");
                    	Alfresco.util.PopupManager.displayMessage({
                            text : Alfresco.util.message("actions.void-document-success")
                        });
                    },
                    scope: this
                 },
                 failureCallback : {
                     fn : function ExtDataListToolbar_onActionVoid_failure(response) {
                       Alfresco.util.PopupManager.displayMessage({
                         text : response.json.message
                       });
                     },
                     scope : this
                  },
                  dataObj:
                  {
                	nodes: this,
                    comment : comment
                  }
              };

              Alfresco.util.Ajax.jsonRequest(config);
           },
           scope: nodes
        }
     });


    },
    /**
     * Revoke an engineering workflow
     *
     * @method onActionRevoke
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onActionRevoke : function ExtDataListToolbar_onActionRevoke(e, p_obj) {
      // Collect nodes to operate on.
      var nodes = [];
      for (var i = 0, j = e.length; i < j; i++) {
        var row = e[i];
        var nodeRef = {
          nodeRef : row.nodeRef
      };

      if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
         Alfresco.util.PopupManager.displayMessage(
    	 {
    	   text: Alfresco.util.message("message.noOngoingWorkflow")
    	 });
         return false;
      }
        nodes.push(nodeRef);
      }

      Alfresco.util.PopupManager.getUserInput(
      {
        title: Alfresco.util.message("dialog.revoke.title"),
        text: Alfresco.util.message("dialog.revoke.reason"),
        input: "text",
        callback:
        {
           fn: function promptCallback (comment)
           {
              url = Alfresco.constants.PROXY_URI + "lyse/api/revoke-document";

              var config =
              {
                 method: "POST",
                 url: url,
                 successCallback:
                 {
                    fn: function (response)
                    {
                        // Fire "dataItemsDuplicated" event to refresh datagrid
                        Bubbling.fire("dataItemsDuplicated");
                    	Alfresco.util.PopupManager.displayMessage({
                            text : Alfresco.util.message("actions.revoke-document-success")
                        });
                    },
                    scope: this
                 },
                 failureCallback : {
                     fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                       Alfresco.util.PopupManager.displayMessage({
                         text : response.json.message
                       });
                     },
                     scope : this
                  },
                  dataObj:
                  {
                	nodes: this,
                    comment : comment
                  }
              };

              Alfresco.util.Ajax.jsonRequest(config);
           },
           scope: nodes
        }
     });


    },
      /**
       * Revoke a safe work permit
       *
       * @method onActionRevokeSafeWorkPermit
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionRevokeSafeWorkPermit : function ExtDataListToolbar_onActionRevokeSafeWorkPermit(e, p_obj) {
          // Collect nodes to operate on.
          var nodes = [];
          for (var i = 0, j = e.length; i < j; i++) {
              var row = e[i];
              var nodeRef = {
                  nodeRef : row.nodeRef
              };

              if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
                // ??
              }
              else {
                nodes.push(nodeRef);
              }
          }

          var config =
              {
                  method: "POST",
                  url: Alfresco.constants.PROXY_URI + "lyse/api/revoke-safe-work-permit",
                  successCallback:
                      {
                          fn: function (response)
                          {
                              // Fire "dataItemsDuplicated" event to refresh datagrid
                              Bubbling.fire("dataItemsDuplicated");
                              // Fire to update the "Selected items" menu
                              Bubbling.fire("selectedItemsChanged");
                              var message = Alfresco.util.message("actions.revoke-safe-work-permit-success");
                              if (response.json.data.failed.length > 0) {
                                  message = Alfresco.util.message("actions.revoke-safe-work-permit-partial-success", this, {
                                    success: response.json.data.success.length,
                                    failed: response.json.data.failed.length
                                  });
                              }
                              Alfresco.util.PopupManager.displayMessage({
                                  text : message
                              });
                          },
                          scope: this
                      },
                  failureCallback : {
                      fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                          Alfresco.util.PopupManager.displayMessage({
                              text : Alfresco.util.message("actions.revoke-safe-work-permit-failed") +
                              (response.json ? response.json.message : response.serverResponse.statusText)
                          });
                      },
                      scope : this
                  },
                  dataObj:
                      {
                          nodes: nodes
                      }
              };

          Alfresco.util.Ajax.jsonRequest(config);
      },

      /**
       * Complete a Civil Measured Quantity
       *
       * @method onActionCompleteCivilMeasuredQuantity
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionCompleteCivilMeasuredQuantity : function ExtDataListToolbar_onActionCompleteCivilMeasuredQuantity(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          var nodeRef = {
              nodeRef : row.nodeRef
          };

          if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
            // ??
          }
          else {
            nodes.push(nodeRef);
          }
        }

        var config =
        {
            method: "POST",
            url: Alfresco.constants.PROXY_URI + "lyse/api/complete-civil-measured-quantities",
            successCallback:
            {
              fn: function (response)
              {
                // Fire "dataItemsDuplicated" event to refresh datagrid
                Bubbling.fire("dataItemsDuplicated");
                // Fire to update the "Selected items" menu
                Bubbling.fire("selectedItemsChanged");
                var message = Alfresco.util.message("actions.complete-civil-measured-quantities-success");
                if (response.json.data.failed.length > 0) {
                  message = Alfresco.util.message("actions.complete-civil-measured-quantities-partial-success", this, {
                    success: response.json.data.success.length,
                    failed: response.json.data.failed.length
                  });
                }
                Alfresco.util.PopupManager.displayMessage({
                  text : message
                });
              },
              scope: this
            },
            failureCallback : {
              fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                Alfresco.util.PopupManager.displayMessage({
                  text : Alfresco.util.message("actions.complete-civil-measured-quantities-failed") +
                  (response.json ? response.json.message : response.serverResponse.statusText)
                });
              },
              scope : this
            },
            dataObj:
            {
              nodes: nodes
            }
        };

        Alfresco.util.Ajax.jsonRequest(config);
      },

      /**
       * Incomplete a Civil Measured Quantity
       *
       * @method onActionIncompleteCivilMeasuredQuantity
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionIncompleteCivilMeasuredQuantity : function ExtDataListToolbar_onActionIncompleteCivilMeasuredQuantity(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          var nodeRef = {
              nodeRef : row.nodeRef
          };

          nodes.push(nodeRef);
        }

        var config =
        {
            method: "POST",
            url: Alfresco.constants.PROXY_URI + "lyse/api/incomplete-civil-measured-quantities",
            successCallback:
            {
              fn: function (response)
              {
                // Fire "dataItemsDuplicated" event to refresh datagrid
                Bubbling.fire("dataItemsDuplicated");
                // Fire to update the "Selected items" menu
                Bubbling.fire("selectedItemsChanged");
                var message = Alfresco.util.message("actions.incomplete-civil-measured-quantities-success");
                if (response.json.data.failed.length > 0) {
                  message = Alfresco.util.message("actions.incomplete-civil-measured-quantities-partial-success", this, {
                    success: response.json.data.success.length,
                    failed: response.json.data.failed.length
                  });
                }
                Alfresco.util.PopupManager.displayMessage({
                  text : message
                });
              },
              scope: this
            },
            failureCallback : {
              fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                Alfresco.util.PopupManager.displayMessage({
                  text : Alfresco.util.message("actions.incomplete-civil-measured-quantities-failed") +
                  (response.json ? response.json.message : response.serverResponse.statusText)
                });
              },
              scope : this
            },
            dataObj:
            {
              nodes: nodes
            }
        };

        Alfresco.util.Ajax.jsonRequest(config);
      },

      onActionCivilMilestoneSubmitInvoice : function ExtDataListToolbar_onActionCivilMilestoneSubmitInvoice(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
          var row = e[i];
          var nodeRef = {
              nodeRef : row.nodeRef
          };
          nodes.push(nodeRef);
        }

        var config =
        {
          method: "POST",
          url: Alfresco.constants.PROXY_URI + "lyse/api/civil-milestone-submit-invoice",
          successCallback:
          {
            fn: function (response)
            {
              // Fire "dataItemsDuplicated" event to refresh datagrid
              Bubbling.fire("dataItemsDuplicated");
              // Fire to update the "Selected items" menu
              Bubbling.fire("selectedItemsChanged");
              var message = Alfresco.util.message("actions.civil-milestone-submit-invoice-success");
              if (response.json.data.failed.length > 0) {
                message = Alfresco.util.message("actions.civil-milestone-submit-invoice-partial-success", this, {
                  success: response.json.data.success.length,
                  failed: response.json.data.failed.length
                });
              }
              Alfresco.util.PopupManager.displayMessage({
                text : message
              });
            },
            scope: this
          },
          failureCallback : {
            fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
              Alfresco.util.PopupManager.displayMessage({
                text : Alfresco.util.message("actions.civil-milestone-submit-invoice-failed") +
                (response.json ? response.json.message : response.serverResponse.statusText)
              });
            },
            scope : this
          },
          dataObj:
          {
            nodes: nodes
          }
        };

        Alfresco.util.Ajax.jsonRequest(config);
      },

      /**
       * Complete a safe work permit
       *
       * @method onActionCompleteSafeWorkPermit
       * @param e
       *            {object} DomEvent
       * @param p_obj
       *            {object} Object passed back from addListener method
       */
      onActionCompleteSafeWorkPermit : function ExtDataListToolbar_onActionCompleteSafeWorkPermit(e, p_obj) {
        // Collect nodes to operate on.
        var nodes = [];
        for (var i = 0, j = e.length; i < j; i++) {
            var row = e[i];
            var nodeRef = {
                nodeRef : row.nodeRef
            };

            if (typeof row.itemData.prop_lysedl_workflowId == 'undefined' || typeof row.itemData.prop_lysedl_workflowId == '') {
                // ??
            }
            else {
                nodes.push(nodeRef);
            }
        }

        var config =
            {
                method: "POST",
                url: Alfresco.constants.PROXY_URI + "lyse/api/complete-safe-work-permit",
                successCallback:
                    {
                        fn: function (response)
                        {
                            // Fire "dataItemsDuplicated" event to refresh datagrid
                            Bubbling.fire("dataItemsDuplicated");
                            // Fire to update the "Selected items" menu
                            Bubbling.fire("selectedItemsChanged");
                            var message = Alfresco.util.message("actions.complete-safe-work-permit-success");
                            if (response.json.data.failed.length > 0) {
                                message = Alfresco.util.message("actions.complete-safe-work-permit-partial-success", this, {
                                  success: response.json.data.success.length,
                                  failed: response.json.data.failed.length
                                });
                            }
                            Alfresco.util.PopupManager.displayMessage({
                                text : message
                            });
                        },
                        scope: this
                    },
                failureCallback : {
                    fn : function ExtDataListToolbar_onActionRevoke_failure(response) {
                        Alfresco.util.PopupManager.displayMessage({
                            text : Alfresco.util.message("actions.complete-safe-work-permit-failed") +
                            (response.json ? response.json.message : response.serverResponse.statusText)
                        });
                    },
                    scope : this
                },
                dataObj:
                    {
                        nodes: nodes
                    }
            };

        Alfresco.util.Ajax.jsonRequest(config);
    },

    /**
     * New Row button click handler
     *
     * @method onNewRow
     * @param e
     *            {object} DomEvent
     * @param p_obj
     *            {object} Object passed back from addListener method
     */
    onNewRow : function ExtDataListToolbar_onNewRow(e, p_obj) {
      var datalistMeta = this.modules.dataGrid.datalistMeta, destination = datalistMeta.nodeRef, itemType = datalistMeta.itemType;

      // Intercept before dialog show
      var doBeforeDialogShow = function DataListToolbar_onNewRow_doBeforeDialogShow(p_form, p_dialog) {
        Alfresco.util.populateHTML([ p_dialog.id + "-dialogTitle", this.msg("label.new-row.title") ], [ p_dialog.id + "-dialogHeader", this.msg("label.new-row.header") ]);
      };

      var templateUrl = YAHOO.lang.substitute(Alfresco.constants.URL_SERVICECONTEXT + "components/form?itemKind={itemKind}&itemId={itemId}&destination={destination}&mode={mode}&submitType={submitType}&site={site}&showCancelButton=true", {
        itemKind : "type",
        itemId : itemType,
        destination : destination,
        mode : "create",
        submitType : "json",
        site: Alfresco.constants.SITE
      });

      // Using Forms Service, so always create new instance
      var createRow = new Alfresco.module.SimpleDialog(this.id + "-createRow");

      createRow.setOptions({
        width : "800px",
        templateUrl : templateUrl,
        actionUrl : null,
        destroyOnHide : true,
        doBeforeDialogShow : {
          fn : doBeforeDialogShow,
          scope : this
        },
        onSuccess : {
          fn : function DataListToolbar_onNewRow_success(response) {
            YAHOO.Bubbling.fire("dataItemCreated", {
              nodeRef : response.json.persistedObject
            });

            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.success")
            });
          },
          scope : this
        },
        onFailure : {
          fn : function DataListToolbar_onNewRow_failure(response) {
            Alfresco.util.PopupManager.displayMessage({
              text : this.msg("message.new-row.failure")
            });
          },
          scope : this
        }
      }).show();
    }

  }, true);
})();
